part of tecfy_core_client_package;

class Message{

  String uid;
  String fromUserId;
  String fromName;
  
  String toUserId;
  String toName;

  String body;
  DateTime time;
  String get timeString => time == null ? '-' : time.difference(DateTime.now()).inDays <= 0 ? '${time.hour}:${time.minute}' : time.toString();

  bool imSender =false;

  Message({this.body,this.fromName, this.toName, this.fromUserId, this.toUserId,this.imSender,this.time});

  Message.sendNew({this.body, this.toUserId}){
    uid = DateTime.now().microsecondsSinceEpoch.toString();
    time = DateTime.now();
    imSender =true;
  }

   Message.fromMap(Map row){
     try{
      uid = row['UID'];
      fromUserId = row['FromUserId'];
      fromName = row['FromName'];
      toUserId = row['ToUserId'];
      toName = row['ToName'];
      body = row['Body'] ;    
      imSender = (row['FromUserId'] == LocalConfigService.user.id); 
      time = DateTime.tryParse(row['Time'].toString().substring(0,23).replaceFirst('T', ' '));
     }catch(err){
       print('---------------------------');
       print(row);
       print(err);
     }
  }
   Message.fromMapHistory(Map row){
     try{
      uid = row['uid'];
      fromUserId = row['fromUserId'];
      fromName = row['fromName'];
      toUserId = row['toUserId'];
      toName = row['toName'];
      body = row['body'] ;    
      imSender = (row['fromUserId'] == LocalConfigService.user.id); 
      time = DateTime.tryParse(row['time'].toString().substring(0,23).replaceFirst('T', ' '));
     }catch(err){
       print('---------------------------');
       print(row);
       print(err);
     }
  }
  Message.fromMapDatabase(Map row){
     try{
      uid = row['uid'];
      fromUserId = row['fromUserId'];
      fromName = row['fromName'];
      toUserId = row['toUserId'];
      toName = row['toName'];
      body = row['body'] ;    
      imSender = (row['fromUserId'] == LocalConfigService.user.id); 
      time = DateTime.fromMillisecondsSinceEpoch(row['time']);
     }catch(err){
       print('---------------------------');
       print(row);
       print(err);
     }
  }

  toMap(){
    return {
      'toUserId' :toUserId,
      'body' :body,
    };
  }
  
  toMapDb(){
    return {
      'uid':uid,
      'fromUserId':fromUserId,
      'fromName':fromName,
      'toUserId' :toUserId,
      'toName':toName,
      'body' :body,
      'imSender' : imSender ? 1 : 0,
      'time': time.millisecondsSinceEpoch
    };
  }


}