part of tecfy_core_client_package;

class WebSocketService{
  
  static bool connected = false;
  static IOWebSocketChannel channel;
  static Stream<dynamic> stream;
  

  static init(){
    
    if(ConfigService.token == null)return;

    try{
      print('========= CHAT====  try tp connect to ${ConnectionService.activeConnection.wsURL}');
      channel = IOWebSocketChannel.connect(ConnectionService.activeConnection.wsURL,headers: {'Authorization': 'Bearer ${ConfigService.token}'},pingInterval: Duration(seconds: 10));
      stream = channel.stream.asBroadcastStream();
      stream.listen((data){
        print('========= CHAT==== new Package revieved -----------------');
        print(data);
        var package = Package.fromMap(json.decode(data));
        packageReceived(package);
      });   
      print('========= CHAT==== Connexted ');
      connected = true;
    }catch(err){
      print('xxxxxxxxxxxxxxx Package socket Error xxxxxxxxxxxxxxxxx ${ConfigService.wsURL}');
      print(err);
      connected = false;
    }
  }

  static packageReceived(Package package)async{
    
    switch(package.type){
      case PackageType.newNotification:
      NotificationAppService.onNotificationReceived(package.data);
      break;
      case PackageType.newMessage:
      MessageService.onMessageReceived(package.data);
      break;
      case PackageType.newMultiNotification:
      package.data.forEach((n)=> NotificationAppService.onNotificationReceived(n));
      break;
      default:

    }
    
  }

  static sendPackage(Package package)async{
    
    dynamic data;
    switch(package.type){
      case PackageType.requestLatestNotification:
      data = package.data;
      break;
      case PackageType.newMessage:
      data = package.data.toMap();
      break;
      default:
      data = package.data;
    }
    WebSocketService.channel.sink.add(json.encode({'type':package.type,'data' :data}));
    
  }

}